<template>
  <div>
    <BasicTable @register="registerTable">
      <template #headerTop>
        <a-alert type="info" show-icon>
          <template #message>
            <template v-if="checkedKeys.length > 0">
              <span>已选中{{ checkedKeys.length }}条记录</span>
              <a-button type="link" @click="checkedKeys = []" size="small">清空</a-button>
              <a-popconfirm
                class="ml-4"
                title="确定要全部删除吗？"
                ok-text="是"
                cancel-text="否"
                @confirm="handleBatchDelete"
              >
                <a href="#" class="text-red-500">删除</a>
              </a-popconfirm>
            </template>
            <template v-else>
              <span>未选中任何项目</span>
            </template>
          </template>
        </a-alert>
      </template>
      <template #toolbar>
        <a-button v-auth="'AUTH_ORDER_BATCH_ORDER_DETAIL:ADD'" type="primary" @click="handleCreate"> 新增</a-button>
      </template>
      <template #bodyCell="{ column, record, text }">
        <template v-if="column.dataIndex === 'id'">
          <a @click="handleView(record)"> {{ record.id }} </a>
        </template>
        <template v-if="[].includes(column.dataIndex)">
          <img :src="text" class="photo" alt="图片" v-if="!!text" />
        </template>
        <template v-if="column.dataIndex === 'action'">
          <TableAction
            :actions="[
              {
                tooltip: '编辑',
                icon: 'clarity:note-edit-line',
                onClick: handleEdit.bind(null, record),
                ifShow: hasPermission('AUTH_ORDER_BATCH_ORDER_DETAIL:EDIT'),
              },
              {
                tooltip: '删除',
                icon: 'ant-design:delete-outlined',
                color: 'error',
                popConfirm: {
                  title: '是否确认删除',
                  confirm: handleDelete.bind(null, record),
                },
                ifShow: hasPermission('AUTH_ORDER_BATCH_ORDER_DETAIL:DELETE'),
              },
            ]"
          />
        </template>
      </template>
    </BasicTable>
    <BatchOrderDetailDrawer @register="registerDrawer" @success="handleSuccess" />
  </div>
</template>
<script lang="ts" setup name="DeviceIndex">
  import { ref } from 'vue';
  import { useGo } from '/@/hooks/web/usePage';
  import { usePermission } from '/@/hooks/web/usePermission';
  import { BasicTable, useTable, TableAction } from '/@/components/Table';
  import { isObject } from '/@/utils/is';
  import moment from 'moment';
  import * as BatchOrderDetailApi from '/@/api/order/batchOrderDetailApi';
  import { useDrawer } from '/@/components/Drawer';
  import componentSetting from '/@/settings/componentSetting';
  import BatchOrderDetailDrawer from './drawer.vue';
  import { columns, searchFormSchema } from './schema';

  const { hasPermission } = usePermission();
  const go = useGo();
  const { formConfig, showTableSetting, bordered, showIndexColumn } = componentSetting.table;

  const checkedKeys = ref<Array<string | number>>([]);
  const onSelectChange = (selectedRowKeys: (string | number)[]) => {
    checkedKeys.value = selectedRowKeys;
  };

  const [registerDrawer, { openDrawer }] = useDrawer();
  const [registerTable, { reload }] = useTable({
    title: '批量订单产品详情表管理',
    api: (params) => BatchOrderDetailApi.search(handleParams(params)),
    columns,
    formConfig: {
      labelWidth: formConfig.labelWidth,
      schemas: searchFormSchema,
      showAdvancedButton: false,
    },
    rowSelection: {
      type: 'checkbox',
      selectedRowKeys: checkedKeys,
      onChange: onSelectChange,
    },
    useSearchForm: true,
    showTableSetting,
    bordered,
    showIndexColumn,
    canResize: false,
    rowKey: (record: any) => record.id,
    actionColumn: {
      width: 80,
      title: '操作',
      dataIndex: 'action',

      fixed: 'right',
    },
  });

  const handleParams = (params) => {
    const { pageNum, pageSize } = params;
    const handledParams: any = { pageNum, pageSize };
    Object.keys(params).forEach((key) => {
      const schema = searchFormSchema.find((item) => item.field === key);
      const value = params[key];
      if (schema && value !== undefined && value !== '') {
        if (schema.component === 'Input') {
          handledParams[key] = `%${value.trim()}%`;
        } else if (['Select', 'ApiSelect'].includes(schema.component)) {
          handledParams[key] = isObject(value) ? value.value : value;
        } else if (schema.component === 'RangePicker') {
          handledParams[`${key}From`] = moment(value[0]).startOf('d').format('YYYY-MM-DD HH:mm:ss');
          handledParams[`${key}To`] = moment(value[1]).endOf('d').format('YYYY-MM-DD HH:mm:ss');
        } else if (schema.component === 'DatePicker') {
          handledParams[key] = moment(value).format((schema.componentProps as any).format || 'YYYY-MM-DD');
        } else {
          handledParams[key] = value;
        }
      }
    });
    return handledParams;
  };

  const handleCreate = () => {
    openDrawer(true, {
      isUpdate: false,
    });
  };

  const handleEdit = (record: Recordable) => {
    openDrawer(true, {
      record,
      isUpdate: true,
    });
  };

  const handleDelete = (record: Recordable) => {
    BatchOrderDetailApi.remove(record.id).then((_) => {
      reload();
    });
  };

  const handleBatchDelete = () => {
    BatchOrderDetailApi.batchRemove(checkedKeys.value).then((_) => {
      reload();
    });
  };

  const handleSuccess = () => {
    reload();
  };

  const handleView = (record) => {
    go('/order/batch-order-detail/' + record.id);
  };
</script>
